/********************************************************
* RANDOM TURING MACHINE SIMULATION                      *
* THEORY OF COMPUTER SCIENCE                            *
* PROF.: Joaquim Quinteiro Ucha [joukim@comp.ufla.br]  *
*                                                       *
* DEVELOPERS:                                           *
* Anderson de Rezende Rocha [undersun@comp.ufla.br]     *
* Jlio Csar Alves         [jcalves@comp.ufla.br]      *
*                                                       *
* BOTH computer scientists undergraduating students   at  *
* UFLA, Lavras Federal University at Lavras, MG, BRAZIL *
********************************************************/

// class nodeList define a node of a simple list

#ifndef NODELIST_H
#define NODELIST_H

using namespace std;

template <class TValue>
class nodeList
// the operator = MUST to be defined in the class TValue
{
    public:
        nodeList();
        ~nodeList();
        nodeList *getNext();
        TValue getValue();
        void copyValue(const TValue &v);
        void setNext(nodeList *node);
    protected:
        TValue *value;
        nodeList *next;
};

template <class TValue>
nodeList<TValue>::nodeList()
{
    value = NULL;
    next = NULL;
}

template <class TValue>
nodeList<TValue>::~nodeList()
{
    if (value != NULL)
        delete value;
}

template <class TValue>
TValue nodeList<TValue>::getValue()
// returns the node's value
{

    return *value;
}

template <class TValue>
nodeList<TValue>* nodeList<TValue>::getNext()
// returns the next node in the list
{
    return next;
}

template <class TValue>
void nodeList<TValue>::setNext(nodeList *node)
// set the next node in the list
{
    next = node;
}

template <class TValue>
void nodeList<TValue>::copyValue(const TValue &v)
// change the node's value
{
    if (value != NULL)
        delete value;
    value = new TValue(v);
}

#endif

